<script lang="ts">
import {
  type ControlElement,
  isOneOfEnumControl,
  type JsonFormsRendererRegistryEntry,
  rankWith,
} from "@jsonforms/core";
import { rendererProps, type RendererProps, useJsonFormsOneOfEnumControl } from "@jsonforms/vue";
import { ControlWrapper, DisabledIconFocus, useVuetifyControl } from "@jsonforms/vue-vuetify";
import { defineComponent } from "vue";
import { VSelect } from "vuetify/components";

const controlRenderer = defineComponent({
  /* eslint-disable vue/component-definition-name-casing */
  name: "oneof-enum-control-renderer",
  /* eslint-enable */
  components: {
    ControlWrapper,
    VSelect,
  },
  directives: {
    DisabledIconFocus,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    return useVuetifyControl(useJsonFormsOneOfEnumControl(props), value =>
      value !== null ? value : undefined);
  },
  methods: {
    customFilter(itemTitle, queryText, item) {
      const title = item.raw.title?.toLowerCase() || "";
      const description = item.raw.description ? item.raw.description.toLowerCase() : "";
      const searchText = queryText.toLowerCase();

      return title.includes(searchText) || description.includes(searchText);
    },
    itemProps(item) {
      return {
        title: item.title,
        subtitle: item.description,
      };
    },
    getErrorMessages(control) {
      // If a custom message is present, use it, otherwise fallback to default errors
      if (control.errors.length !== 0) {
        return control.schema.errorMessage?.required
          ? [control.schema.errorMessage?.required]
          : control.errors;
      } else {
        return [];
      }
    },
  },
});

export default controlRenderer;

export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(5, isOneOfEnumControl),
};
</script>

<template>
  <ControlWrapper
    v-bind="controlWrapper"
    :styles="styles"
    :isFocused="isFocused"
    :appliedOptions="appliedOptions"
  >
    <v-autocomplete
      v-if="'format' in control.schema && control.schema.format === 'autocomplete'"
      :id="`${control.id}-input`"
      v-disabled-icon-focus
      :class="styles.control.input"
      :disabled="!control.enabled"
      :autofocus="appliedOptions.focus"
      :placeholder="appliedOptions.placeholder"
      :label="computedLabel"
      :hint="control.description"
      :persistent-hint="persistentHint()"
      :required="control.required"
      :error-messages="getErrorMessages(control)"
      :clearable="control.enabled"
      :model-value="control.data"
      :items="control.schema.oneOf"
      item-value="const"
      :item-props="itemProps"
      v-bind="vuetifyProps('v-select')"
      :custom-filter="customFilter"
      @update:model-value="onChange"
      @focus="handleFocus"
      @blur="handleBlur"
    />
    <VSelect
      v-else
      :id="`${control.id}-input`"
      v-disabled-icon-focus
      :class="styles.control.input"
      :disabled="!control.enabled"
      :autofocus="appliedOptions.focus"
      :placeholder="appliedOptions.placeholder"
      :label="computedLabel"
      :hint="control.description"
      :persistent-hint="persistentHint()"
      :required="control.required"
      :error-messages="control.errors"
      :model-value="control.data"
      :items="control.options"
      item-title="label"
      item-value="value"
      v-bind="vuetifyProps('v-select')"
      @update:model-value="onChange"
      @focus="handleFocus"
      @blur="handleBlur"
    />
  </ControlWrapper>
</template>
